#include <sourcemod>
#include <sdktools>

#pragma semicolon 1 

public Plugin myinfo = 
{
    name = "Mare Usernames",
    author = "Washing Machine, Knucklehead McSpazatron, Gonderlane",
    description = "Gives you a My Little Pony: Friendship is Magic based username",
    version = "2.002",
    url = "https://boards.4channel.org/mlp/tf2" 
};

char FirstNames[][] = 
{
"Amber","Amethyst","Astral","Aqua","Azure","Autumn","Adorable",
"Bronze","Blurry","Blueberry","Berry","Banana",
"Carrot","Candy","Celestial","Cheese","Cherry","Cinnamon","Cookie","Crystal","Curvy","Chocolate","Caramel","Cutesy","Clever",
"Daffy","Dew","Dizzy","Dotty","Dozy","Dancing","Delicious","Deep",
"Ebony","Electric","Emerald",
"Fancy","Flawless","Fluffy",
"Giddy","Ginger","Golden","Goofy", 
"Hazel","Honey","Happy",
"Ice","Indigo","Inky","Ivory","Ivy",
"Jolly","Juicy","Jade",
"Kindle","Kind","Keen",
"Lapis","Lila","Lilly","Little","Lucky","Lunar","Lemon","Lovely",
"Merry","Messy","Misty","Midnight","Mythic","Morning",
"Nettle","Nimble","Nifty",
"Orange","Orchid","Ocean",
"Pearl","Pastel","Perfect","Pecan","Pumpkin","Pretty","Pleasant","Pure","Plump",
"Rainbow","River","Rose","Ruby","Raspberry","Radiant",
"Sapphire","Scarlet","Shadow","Silly","Sleepy","Snazzy","Snowy","Soft","Spooky","Squeaky","Strawberry","Sweet","Sugar","Sunny","Stunning","Sunrise","Simple",
"Twilight","Twinkle","Tricky","Tasty","Tiny",
"Velvet","Violet","Vanilla",
"Wacky","Water","Winter","Wild",
"Yummy","Yellow",
};

char LastNames[][] =
{
"Aura","Aurora","Anemone",
"Bee","Blossom","Blush","Breeze","Bubbles","Bell","Blaze",
"Cake","Cream","Candy","Cupcake","Camellia",
"Daisy","Dawn","Dazzle","Diamond","Drop","Dusk","Daffodil","Dahlia",
"Eyes",
"Fashion","Frost","Flanks",
"Gem","Glow","Grace","Giggle","Grape",
"Harmony","Hooves","Heart",
"Jam","Jewel","Joy","Jasmine",
"Kisses","Kiss",
"Light","Love","Lilac",
"Mint","Moon","Moonlight",
"Night","Nourish",
"Petal","Pie","Plum","Pudding","Passion","Peach",
"Rain","Rose",
"Shadow","Snowflake","Song","Sorbet","Sparkle","Spice","Star","Sunlight","Swirl","Sea","Smiles","Sky","Shimmer",
"Twirl","Tulip",
"Whistles","Wings","Wish",
};

char SimpleNames[][] =
{
"Blossomforth",
"Charm","Cornflower","Creamcup",
"Dosie",
"Gigglecake",
"Hazelblossom",
"Jetstream","Junebug",
"Linky",
"Flitter",
"Minuette",
"Sassaflash","Shoeshine","Slipstream","Sunshower",
"Twinkleshine",
};

char RareFirstNames[][] =
{
"Ditzy",
"Purple",
"Smutty",
"Yoinky",
"Ponka",
};

char RareLastNames[][] =
{
"Mare",
"Pony", "Poni",
"Snowpity","Sploinky"
};

char RareSimpleNames[][] =
{
"Anonymous","Applejack",
"Cheese Sandwich","Chucklenuts","Cloud Treasure",
"Derpy Hooves",
"Fluttershy",
"Lyra Heartstrings",
"Nurse Redheart",
"Purple Smart",
"Rainbowshine","Rarity",
"Sniper"
};

char NamePrefixes[][] =
{
"Doctor",
"Princess",
"Sgt.",
"The Real",
"Nurse",
};

char NameException[][] = {
"HorseTV",
"SourceTV",
};

public void OnClientConnected(int client) {
	NameChange(client);
}

// attempt to circumvent setclientname bug.. ugly :(
void NameChange(int client) { 
	static ConVar sv_namechange_cooldown_seconds;
	if (!sv_namechange_cooldown_seconds) {
		sv_namechange_cooldown_seconds = FindConVar("sv_namechange_cooldown_seconds");
	}
	float OriginalValue = sv_namechange_cooldown_seconds.FloatValue;
	sv_namechange_cooldown_seconds.FloatValue = 0.0; // this assumably helps prevent server from preventing name change
	
	char Username[MAX_NAME_LENGTH];
	GetClientName(client, Username, MAX_NAME_LENGTH);
	bool exception = CheckNameException(Username);
	if (exception != true) { 
		SetClientName(client, "NAME PLACEHOLDER");
		RequestFrame(GiveMareName, client); // executes function on next frame
	}
	
	sv_namechange_cooldown_seconds.FloatValue = OriginalValue;
}

// gets randomized mare name and issues it to player
void GiveMareName(int client) {
	char Username[MAX_NAME_LENGTH];

	for (int tries = 1; tries <= 20; tries++) {       	
		switch(GetRandomInt(1,20)){ // 1:x chance to get simple vs compound name
	    
			case 1: { // simple
				ApplyRandomString(Username, MAX_NAME_LENGTH,
				RareSimpleNames, sizeof(RareSimpleNames),
				SimpleNames, sizeof(SimpleNames), 20);
			}
			
			default: { // compound
			    char FirstName[MAX_NAME_LENGTH]; // first name
			    ApplyRandomString(FirstName, MAX_NAME_LENGTH,
				RareFirstNames, sizeof(RareFirstNames),
				FirstNames, sizeof(FirstNames), 20);
				
			    char LastName[MAX_NAME_LENGTH]; // last name
			    ApplyRandomString(LastName, MAX_NAME_LENGTH,
				RareLastNames, sizeof(RareLastNames),
				LastNames, sizeof(LastNames), 20);

				Format(Username, MAX_NAME_LENGTH, "%s %s", FirstName, LastName); // combine

				switch(GetRandomInt(1,100)){ // potential prefix
					case 1:{
						Format(Username, MAX_NAME_LENGTH, "%s %s", 
						NamePrefixes[GetRandomInt(0, sizeof(NamePrefixes) - 1)], Username);
					}
				}
			}

	    }

		bool legality = CheckNameLegal(client, Username);
		if (legality == true) {
			break;
		}
	}	
	
	SetClientName(client, Username);
	
	// if sudden influx of joins, legality check can be bypassed
	// this hopefully fixes the issue
	char ChangedUsername[MAX_NAME_LENGTH];
	GetClientName(client, ChangedUsername, MAX_NAME_LENGTH);
	if (StrContains(ChangedUsername, "(1)") != -1) { 
		RequestFrame(NameChange, client);
	}
}

// applies random string from randomarray based off 1:x chance to buffer
// if else, then normalarray is used
void ApplyRandomString(char[] buffer, int size, char[][] RareArray, int raresize, char[][] NormalArray, int normalsize, int x) {
	switch(GetRandomInt(1, x)) { // 1:x chance to get rare vs simple name
		case 1: { // rare
			strcopy(buffer, size, RareArray[GetRandomInt(0, raresize - 1)]); // copies one string to another (random to buffer)
		}
		
		default: { // simple
			strcopy(buffer, size, NormalArray[GetRandomInt(0, normalsize - 1)]); 
		}
	}
}

// checks if name is on name-change blacklist
bool CheckNameException(char[] Username) { 
	for (int i = 0; i < sizeof(NameException); i++) {
		if (StrEqual(Username, NameException[i]) == true) {
			return true;
		}
	}

	return false;
}

// checks if anyone on server has same randomized name
bool CheckNameLegal(int client, char[] Username) { 
    for (int i = 1; i <= MaxClients; i++)
    {
        if (IsClientInGame(i) && client != i) {
            char PlayerUsername[MAX_NAME_LENGTH];
            GetClientName(i, PlayerUsername, sizeof(PlayerUsername));
            if (StrEqual(PlayerUsername, Username)) {
                return false;
            }
        }
    }
    
    return true;
}

/*
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢠⠶⢤⡀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⢀⣀⡀⠀⢀⣠⣤⣴⣶⣶⡦⠤⢤⣤⣀⣀⣼⠀⠀⡽⣄⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⠈⠫⣯⠙⡟⢿⣿⣿⡿⠁⠀⢠⣾⣿⣿⣿⡿⠀⠀⢹⠘⡆⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⠀⣼⣿⣷⣧⡀⢱⠈⠀⠀⠀⣿⣿⣿⣿⣿⡀⠀⠀⢸⠀⢳⠀⠀⠀⠀    I Love Mares⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⣼⣿⣿⣿⣿⣿⣿⡄⢀⣀⣠⣿⣿⣿⠿⢿⣷⣤⡀⠈⠀⡟⠀⠀⠀Oh My God, I Love Them⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⢠⣿⣿⣿⣿⣿⣿⠿⠛⠉⠉⠀⡇⣾⣿⣦⣀⣿⡄⠀⠀⢰⠃⠀⠀⠀  Entirely, Forever⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⢸⣿⣿⣿⠿⢯⣷⢄⠀⠀⠀⠀⡄⢻⣿⣯⣻⣿⡧⠄⠀⢸⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠘⣿⠟⠁⠀⠚⢻⣦⣱⣄⠀⠀⢣⠈⠛⣽⣿⠿⠭⠀⣠⣿⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⣠⡤⠶⠶⠶⠶⢤⣄⡀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⠁⠀⠀⠀⠀⠀⠻⣿⣿⠀⠀⠈⠂⠀⠀⢀⣄⣠⣴⣿⣿⠀⠀⠀⠀⠀⠀⠀⠀⠀⣠⠶⠋⠁⠀⠀⠀⠀⠀⠀⠀⠉⠳⢦⡀⠀⠀⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⣸⠋⠄⢠⠀⠀⠀⠀⣾⣿⣿⣿⣿⣿⡀⠀⠀⠀⠀⠀⠀⠀⡴⠃⠀⣠⣤⣶⣶⣾⣶⣶⣦⣄⠀⠀⠀⠹⣆⠀⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠈⠲⠴⠯⠤⠤⢶⢾⣿⣿⣿⣿⣿⠏⠷⣄⢀⣀⣀⣀⡀⣼⣠⣴⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⡀⠀⠀⠸⣧⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢠⠏⠈⠉⣡⣾⣿⠏⠀⢰⣿⠉⣩⠀⠉⢙⣿⡿⠛⠉⠉⠙⠛⢿⣿⣿⣿⣿⣿⣿⣷⠀⠀⠀⢻⣇⠀⠀
⠀⠀⠀<mare>⠀⠀⠀⠀⢀⡟⠀⠀⣿⣿⡿⠋⠀⢀⣾⡿⠀⣉⣀⣇⠘⠋⣿⠀⠀⠀⠀⠀⠀⠙⣿⣿⣿⣿⣿⣿⡆⠀⠀⢸⣿⡆⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢸⠃⠀⠀⠘⢯⡀⠀⢀⣾⣿⠇⣴⠨⣿⣿⡯⠀⢸⠀⠀⠀⠀⠀⠀⠀⠘⣿⣿⣿⣿⣿⡇⠀⠀⢸⣿⣷⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠸⡆⠀⠀⠀⠈⠻⢦⣾⣿⠏⠀⠈⢈⣝⡟⠁⣶⣾⠀⠀⠀⠀⠀⠀⠀⠀⢹⣿⣿⣿⣿⡇⠀⠀⢸⣿⣿⡀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢻⡀⢄⣀⡀⠀⠀⠉⠁⠀⠰⣄⠀⠁⠀⠀⢀⡏⠀⠀⠀⠀⠀⠀⠀⠀⠈⣿⣿⣿⣿⠃⠀⠀⣸⣿⣿⡇
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⢷⡀⢹⠁⠀⢠⠶⠤⠤⢴⡾⢦⡀⠀⠀⣼⠦⡄⠀⠀⠀⠀⠀⠀⠀⠀⣿⣿⣿⣿⠀⠀⠀⣿⣿⣿⠇
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠈⣷⠇⠀⠀⢸⡄⠀⠀⠀⠙⢆⠙⢦⡀⠀⠀⠙⣦⠀⠀⠀⠀⠀⠀⠀⣿⣿⣿⡇⠀⠀⢰⣿⡿⠋⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡟⠀⠀⠀⡟⢻⡀⠀⠀⠀⠈⢳⡀⢳⡀⠀⠀⠈⢧⡀⠀⠀⠀⠀⠀⣿⣿⣿⠁⠀⢀⣼⠟⠁⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡞⠀⠀⠀⠀⡇⠀⢧⠀⠀⠀⠀⠀⢷⠀⢳⠀⠀⠀⠈⢧⠀⠀⠀⠀⢀⣿⣿⡏⢀⣴⠟⠁⠀⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡞⠀⠀⠀⠀⢸⠇⠀⠸⡆⠀⠀⠀⠀⢸⠀⢸⡇⠀⠀⠀⠘⣧⠀⠀⠀⢸⣿⣿⡷⠛⠁⠀⠀⠀⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢀⡞⠀⠀⠀⠀⠀⣾⠀⠀⠀⣧⠀⠀⠀⠀⢸⠀⠀⡇⠀⠀⠀⠀⢸⡆⠀⠀⣿⠿⠋⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⢠⠎⠀⠀⠀⠀⠀⣰⠇⠀⠀⠀⣿⠀⠀⠀⠀⣏⣀⣸⠇⠀⠀⠀⠀⠀⣷⠀⠈⠁⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠻⠤⣤⣤⣤⡤⠴⠛⠛⠛⠛⠉⠁⠀⠀⠀⠀⠈⠉⢿⣄⣀⣠⣤⡤⠶⠋⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀
*/